<?php

/*
Plugin Name: Weather Function
Plugin URI: http://nothingoutoftheordinary.com/2007/05/29/wordpress-weather-widget/
Description: Like widget, but just prints out the weather information part
Author: James Wilson
Version: 1.0
Author URI: http://nothingoutoftheordinary.com
*/

function weather($location, $formatting="", $partnerid='1036672568', $licensekey='561e1a02298548de', $imageloc='http://nothingoutoftheordinary.com/weatherimages/') {
	
	$location = urlencode($location);
	$partnerid = urlencode($partnerid);
	$licensekey = urlencode($licensekey);
	if($formatting == "") {
		$formatting = '<img src="%iconhref%" alt="%cond%" style="float:right;" />
%loc%<br />
<span style="font-size: 150%;">%temp% F</span>
(%feels% F)<br />
<span style="font-size: 65%; float: right;">%attribution%</a>';
	}
	
	$uri = 'http://xoap.weather.com/weather/local/' . $location . '?cc=*&prod=xoap&par=' . $partnerid . '&key=' . $licensekey;
	$data = file_get_contents($uri);

	if($data != "") {
		$start = strpos($data, "<cc>");
		$cc = substr($data, $start, strpos($data,"</cc>") - $start);
		if($cc != "") {
			// Location
			$start = strpos($cc,"<obst>") + 6;
			$loc = substr($cc, $start, strpos($cc, "</obst>") - $start);
			
			// Temperature
			$start = strpos($cc, "<tmp>") + 5;
			$temp = substr($cc, $start, strpos($cc, "</tmp>") - $start);
			
			// Feels like
			$start = strpos($cc, "<flik>") + 6;
			$feels = substr($cc, $start, strpos($cc, "</flik>") - $start);
			
			// Conditions, called <t> for some reason
			$start = strpos($cc, "<t>") + 3;
			$cond = substr($cc, $start, strpos($cc, "</t>") - $start);
			
			// Icon number
			$start = strpos($cc, "<icon>") + 6;
			$icon = substr($cc, $start, strpos($cc, "</icon>") - $start);
			
		}
	}

	$attribution = '<a href="http://www.weather.com/?prod=xoap&par=' . $partnerid . '">Weather data provided by weather.com&reg;</a>';
	$iconhref = $imageloc . $icon . '.png';

	$content = str_replace(
		array (
			"%loc%",
			"%temp%",
			"%feels%",
			"%cond%",
			"%icon%",
			"%iconhref%",
			"%attribution%"
		) ,
		array (
			$loc,
			$temp,
			$feels,
			$cond,
			$icon,
			$iconhref,
			$attribution
		) ,
		$formatting
	);
	
	return $content;
}